// src/schedulables_tree_widget.hh - Copyright 2005, 2006, University
//               of Padova, dept. of Pure and Applied
//               Mathematics
//
// This file is part of SGPEMv2.
//
// This is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// SGPEMv2 is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with SGPEMv2; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA

#ifndef SCHEDULABLES_TREE_WIDGET_HH
#define SCHEDULABLES_TREE_WIDGET_HH 1

#include "config.h"

#include <gtkmm/treeview.h>
#include <gtkmm/treestore.h>
#include <gtkmm/menu.h>
#include <gtkmm/uimanager.h>
#include <gtkmm/actiongroup.h>
#include <gtkmm/dialog.h>
#include <libglademm/xml.h>

#include "backend/history_observer.hh"

namespace sgpem
{
  /**
   \brief Temporary class to be used to proceed with the development
   of the GUI until the cairo-based widget are fully working
   */
  class SchedulablesTreeWidget : public Gtk::TreeView, public HistoryObserver
  {
  public:
    SchedulablesTreeWidget();
    virtual ~SchedulablesTreeWidget();

    virtual void update(const History& history);
    
    bool on_button_press_event(GdkEventButton* event);

  private:
    void _on_add_process();
    
    Glib::RefPtr<Gtk::TreeStore> _model;
    Gtk::TreeModelColumnRecord _columns;
    Gtk::TreeModelColumn<Glib::ustring> _column;
    Glib::RefPtr<Gtk::ActionGroup> _action_group;
    Glib::RefPtr<Gtk::UIManager> _UIManager;
    Gtk::Menu* _menu;
    Glib::RefPtr<Gnome::Glade::Xml> _add_process_dialog_glade;
    Gtk::Dialog* _add_process_dialog;
  };

} //~ namespace sgpem


#endif //~ SCHEDULABLES_TREE_WIDGET_HH
